// text : the pmwiki textarea id
// guidatebbtn : guiedit date button id
// showCalendar(format, showsTime, showsOtherMonths)
//<input type="reset" value=" ... "
//onclick="return showCalendar( '%A %d/%m/%Y');">

var calDateMopen = 'bb'; // calOpen;
var calDateMclose = 'cc'; // calClose;


// This function gets called when the end-user clicks on some date.
function selected(cal, date) {
// var calDateMopen = 'aaa';
// var calDateMclose = 'bbb';

  // cal.sel.value = date; // just update the date in the input field.
     
    if (cal.sel.setSelectionRange > '') { // Mozilla, Firefox
	  var start = cal.sel.selectionStart;
	  if (start == cal.sel.value.length) { start = 0; }
	  var top = cal.sel.scrollTop;
	    cal.sel.value = cal.sel.value.substring(0,start)
	      + calDateMopen + date + calDateMclose
	      + cal.sel.value.substring(start);
	    cal.sel.focus();
	    cal.sel.selectionStart = cal.sel.selectionEnd = start + calDateMopen.length + date.length + calDateMclose.length - 1;
	    cal.sel.scrollTop = top;
	} else 
	if (document.selection) { // IE
	var range = document.selection.createRange();
    var str = range.text; // Selected text
    cal.sel.focus();
    document.selection.createRange().text = calDateMopen + date + calDateMclose + str;
	// To put the cursor one char before the end
	range = document.selection.createRange();
	range.move('character', -1);
	range.select();	
  } else {
    cal.sel.value += calDateMopen + date + calDateMclose; }

	
  if (cal.dateClicked)
    // we add this call we close the calendar on single-click.
    cal.callCloseHandler();
}

// And this gets called when the end-user clicks on the _selected_ date,
// or clicks on the "Close" button.  It just hides the calendar without
// destroying it.
function closeHandler(cal) {
  cal.hide();                        // hide the calendar
//  cal.destroy();
  _dynarch_popupCalendar = null;
}

// This function shows the calendar under the element having the given id.
// It takes care of catching "mousedown" signals on document and hiding the
// calendar if the click was outside.
function showCalendar(format, calOpen, calClose, showsTime, showsOtherMonths) {
calDateMopen = calOpen;
calDateMclose = calClose;

  var el = document.getElementById('text'); // the pmwiki textarea id
  if (_dynarch_popupCalendar != null) {
    // we already have some calendar created
    _dynarch_popupCalendar.hide();                 // so we hide it first.
  } else {
    // first-time call, create the calendar.
    var cal = new Calendar(1, null, selected, closeHandler);
    // uncomment the following line to hide the week numbers
    cal.weekNumbers = false;
    if (typeof showsTime == "string") {
      cal.showsTime = false;
      cal.time24 = (showsTime == "24");
    }
    if (showsOtherMonths) {
      cal.showsOtherMonths = true;
    }
    _dynarch_popupCalendar = cal;     // remember it in the global var
    cal.setRange(1900, 2070);        // min/max year allowed.
    cal.create();
  }
  _dynarch_popupCalendar.setDateFormat(format);    // set the specified date format
  _dynarch_popupCalendar.setTtDateFormat(format);  // noe : set the date format of calendar state bar
  _dynarch_popupCalendar.parseDate(el.value);      // try to parse the text in field
  _dynarch_popupCalendar.sel = el;                 // inform it what input field we use

  // the reference element that we pass to showAtElement is the button that
  // triggers the calendar.  In this example we align the calendar bottom-right
  // to the button.
  var elbutton = document.getElementById('guidatebbtn'); // noe : guiedit date button id
  _dynarch_popupCalendar.showAtElement(elbutton, "Br");        // show the calendar

  return false;
}
/*
var MINUTE = 60 * 1000;
var HOUR = 60 * MINUTE;
var DAY = 24 * HOUR;
var WEEK = 7 * DAY;
*/
// If this handler returns true then the "date" given as
// parameter will be disabled.  In this example we enable
// only days within a range of 10 days from the current
// date.
// You can use the functions date.getFullYear() -- returns the year
// as 4 digit number, date.getMonth() -- returns the month as 0..11,
// and date.getDate() -- returns the date of the month as 1..31, to
// make heavy calculations here.  However, beware that this function
// should be very fast, as it is called for each day in a month when
// the calendar is (re)constructed.
function isDisabled(date) {
  var today = new Date();
  return (Math.abs(date.getTime() - today.getTime()) / 60 * 1000 * 60 * 24) > 10;
  // return (Math.abs(date.getTime() - today.getTime()) / DAY) > 10;

}